(ns com.aurellem.exp.pokemon
  "Here I find out how pokemon are stored in memory."
  (:use (com.aurellem.gb gb-driver items assembly util
                         characters))
  (:import [com.aurellem.gb.gb_driver SaveState]))


(def pidgeot-lvl-36 (mid-game))


(def pidgeot-lvl-37 (read-state "pidgeot-lvl-37"))


(def pidgeot-lvl-38  (read-state "pidgeot-lvl-38"))


(def pidgeot-lvl-39  (read-state "pidgeot-lvl-39"))


(def pidgeot-lvl-40  (read-state "pidgeot-lvl-40"))


(defn level-analysis []
  (apply common-differences
         (map (comp vec memory)
              [pidgeot-lvl-36
               pidgeot-lvl-37
               pidgeot-lvl-38
               pidgeot-lvl-39
               pidgeot-lvl-40])))

;; inconclusive -- implies that level is calculated from
;; some other values.


(def name-pidgeotto (read-state "name-pidgeotto"))
(def named-A (read-state "named-A"))
(def named-B (read-state "named-B"))
(def named-C (read-state "named-C"))
(def named-D (read-state "named-D"))
(def named-E (read-state "named-E"))
(def named-F (read-state "named-F"))

(defn name-analysis []
  (apply common-differences
         (map (comp vec memory)
              [named-A
               named-B
               named-C
               named-D
               named-E
               named-F])))

;; resluted in 3 separate locations that could
;; possibly hold the first letter of the pokemon's name

0xCF4A
0xD2EB
0xCEED

;; try changing each of them


(defn test-cf4a []
  (continue!
   (set-memory named-A 0xCF4A (character->character-code "Z"))))
;; result -- pidgeotto named "A"

(defn test-d2eb []
  (continue!
   (set-memory named-A 0xD2EB (character->character-code "Z"))))
;; result -- pidgeotto named "Z"

(defn test-ceed []
  (continue!
   (set-memory named-A 0xCEED (character->character-code "Z"))))
;; result -- pidgeotto named "A"

(def sixth-pokemon-name-start 0xD2EB)


(defn set-sixth-pokemon-name-first-character
  ([state character]
     (set-memory state sixth-pokemon-name-start
                 (character->character-code character)))
  ([character]
     (set-sixth-pokemon-name-first-character @current-state
                                             character)))


(def end-of-name-marker 0x50)
(def max-name-length 11)

(defn sixth-pokemon-name [^SaveState state]
  (character-codes->str
   (take-while
    (partial not= 0x50)
    (subvec (vec (memory state))
            sixth-pokemon-name-start
            (+ (inc max-name-length)
               sixth-pokemon-name-start)))))
          

